//##########################################################################################################################
// Filename:
//  lib_usart.h
// Version:     Letzte Aenderung:     Author:
//  API004          22.01.2008          JS
// Modulbeschreibung:
// Usart-Konfiguration
/*H**************************************************************************
* $RCSfile: lib_usart.h,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* RELEASE:      $Name:  $
* REVISION:     $Revision: 1.14 $
* FILE_CVSID:   $Id: uart_lib.h,v 1.14 2003/08/29 12:45:13 jberthy Exp $
*----------------------------------------------------------------------------
* PURPOSE:
* UART lib header file
*****************************************************************************/

#ifndef _UART_LIB_H_
#define _UART_LIB_H_

/*_____ D E F I N I T I O N S ______________________________________________*/
#define 	UART_8N1 ((1<<USBS1)|(1<<UCSZ11)|(1<<UCSZ10))   // 8data noPar 1Stop
#define XON  0x11
#define XOFF 0x13

/*_____ C O N F I G U R A T I O N _________________________________________*/

#define  COMM_RXTX_BUF_0     //   define: TX-Buffer = RX-Buffer,(Frage-Antwort-Protokolle,z.b. Dold, Modbus)
#define  COMM_RXTX_BUF_1     //   define: TX-Buffer = RX-Buffer,(Frage-Antwort-Protokolle,z.b. Dold, Modbus)

// define: receive-Zeichentimeout wird bearbeitet(Modbus etc.);
// wenn abgelaufen, wird rx verworfen, Applikation muss Timeout erst wieder neu setzen.
#define  RX_TIMEOUT_0
#define  RX_TIMEOUT_1

#define  UART0_CFG   UART_8N1
#define  UART1_CFG   UART_8N1

#define USART0_RX_BUFFER_SIZE 32      /* 2,4,8,16,32,64,128 or 256 bytes */
#define USART0_TX_BUFFER_SIZE 32      /* 2,4,8,16,32,64,128 or 256 bytes */

#define USART1_RX_BUFFER_SIZE 128      /* 2,4,8,16,32,64,128 or 256 bytes */
#define USART1_TX_BUFFER_SIZE 128      /* 2,4,8,16,32,64,128 or 256 bytes */

// Definitionen von Konstanten

#define UART_SET_BAUD_0(bdr)  ( UBRR0H = (unsigned char)((((unsigned long)FOSC)/((unsigned long)bdr*16)-1)>>8),\
                                UBRR0L = (unsigned char)(((unsigned long)FOSC )/((unsigned long)bdr*16)-1)    )
#define UART_SET_BAUD_1(bdr)  ( UBRR1H = (unsigned char)((((unsigned long)FOSC)/((unsigned long)bdr*16)-1)>>8),\
                                UBRR1L = (unsigned char)(((unsigned long)FOSC )/((unsigned long)bdr*16)-1)    )
#define UART_SET_BAUD_WORD(bdr)  ((unsigned int) (((unsigned long)FOSC)/((unsigned long)bdr*16) -1))

// UART0
#define USART0_RX_BUFFER_MASK ( USART0_RX_BUFFER_SIZE - 1 )
#define USART0_TX_BUFFER_MASK ( USART0_TX_BUFFER_SIZE - 1 )

#if ( USART0_RX_BUFFER_SIZE & USART0_RX_BUFFER_MASK )
	#error RX buffer size is not a power of 2
#endif
#if ( USART0_TX_BUFFER_SIZE & USART0_TX_BUFFER_MASK )
	#error TX buffer size is not a power of 2
#endif

// UART1
#define USART1_RX_BUFFER_MASK ( USART1_RX_BUFFER_SIZE - 1 )
#define USART1_TX_BUFFER_MASK ( USART1_TX_BUFFER_SIZE - 1 )

#if ( USART1_RX_BUFFER_SIZE & USART1_RX_BUFFER_MASK )
	#error RX buffer size is not a power of 2
#endif
#if ( USART1_TX_BUFFER_SIZE & USART1_TX_BUFFER_MASK )
	#error TX buffer size is not a power of 2
#endif


#ifndef UART_CONFIG
  #define UART_CONFIG     MSK_UART_8BIT
#endif

#define Enable_interrupt() asm("SEI");
#define Disable_interrupt() asm("CLI");

/*_____ D E C L A R A T I O N ______________________________________________*/

/*_____ M A C R O S ________________________________________________________*/

/*_____ P R O T O T Y P E S ____________________________________________________________*/
void Init_usart0(char refresh);   // bleibt disabled
void Init_usart1(char refresh);   // bleibt disabled

extern void Test_Mm(void);

#endif /* _UART_LIB_H_ */
